//+------------------------------------------------------------------+
//|                                                   ma crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double FastOmaPeriod   = 5;
extern double FastOmaSpeed    = 3;
extern bool   FastOmaAdaptive = true;
extern int    FastOMaPrice    = PRICE_CLOSE;
extern double SlowOmaPeriod   = 8;
extern double SlowOmaSpeed    = 3;
extern bool   SlowOmaAdaptive = true;
extern int    SlowOMaPrice    = PRICE_CLOSE;

extern bool   ShowMaLines     = false;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";
extern string note7           = "Arrow Type";
extern string note8           = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9           = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10          = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11          = "9=Thumb,10=Finger";
extern int    ArrowType       = 2;
extern int    arrowSize       = 2;
extern int    linethickness   = 2;

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double fastMa[];
double slowMa[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{  
   switch(ArrowType)
   {
      case 0  : int arrowUp = 119; int arrowDn = 119; break;
      case 1  :     arrowUp = 233;     arrowDn = 234; break;
      case 2  :     arrowUp = 225;     arrowDn = 226; break;
      case 3  :     arrowUp = 241;     arrowDn = 242; break;
      case 4  :     arrowUp = 221;     arrowDn = 222; break;
      case 5  :     arrowUp = 217;     arrowDn = 218; break;
      case 6  :     arrowUp = 228;     arrowDn = 230; break;
      case 7  :     arrowUp = 236;     arrowDn = 238; break;
      case 8  :     arrowUp = 246;     arrowDn = 248; break;
      case 9  :     arrowUp =  67;     arrowDn =  68; break;
      case 10 :     arrowUp =  71;     arrowDn =  72; break;
   } 
   
   IndicatorBuffers(5);  
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,arrowUp);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,arrowDn);
   SetIndexBuffer(2,fastMa);
   SetIndexBuffer(3,slowMa);
   SetIndexBuffer(4,trend);
   
   if (ShowMaLines)
   {
     SetIndexStyle(2,DRAW_LINE,0,linethickness); 
     SetIndexStyle(3,DRAW_LINE,0,linethickness); 
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }       
   
         //
         //
         //
         //
         //
         
         FastOmaPeriod     = MathMax(FastOmaPeriod,   1);
         FastOmaSpeed      = MathMax(FastOmaSpeed ,-1.5);
         SlowOmaPeriod     = MathMax(SlowOmaPeriod,   1);
         SlowOmaSpeed      = MathMax(SlowOmaSpeed ,-1.5);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
         
   IndicatorShortName(timeFrameToString(timeFrame)+  " OMA Cross ");
return(0);
}

//
//
//
//
//

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {   
     for(i=limit; i>=0; i--)
     {
        fastMa[i]  = iOma(iMA(NULL,0,1,0,MODE_SMA,FastOMaPrice,i),FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,i,0);              
        slowMa[i]  = iOma(iMA(NULL,0,1,0,MODE_SMA,SlowOMaPrice,i),SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,i,1);
        trend[i]   = trend[i+1];
           if (fastMa[i]>slowMa[i]) trend[i] = 1;
           if (fastMa[i]<slowMa[i]) trend[i] =-1;

           //
           //
           //
           //
           //
      
          CrossUp[i] = EMPTY_VALUE;
          CrossDn[i] = EMPTY_VALUE;
          if (trend[i]!= trend[i+1])
          if (trend[i] == 1)
                CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
          else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
         }
         
      manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
  
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOMaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOMaPrice,4,y);
            fastMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOMaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOMaPrice,2,y);
            slowMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOMaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOMaPrice,3,y);
            CrossUp[i] = EMPTY_VALUE;
            CrossDn[i] = EMPTY_VALUE;
            if (trend[i]!= trend[i+1])
            if (trend[i] == 1)
                  CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
            else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
      }
  manageAlerts();
return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][14];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Ma Cross ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ma Cross "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}